#include "rsl/dlmintf.h"
#include <string>
#include <fstream>      // std::ofstream
#include <time.h>
#include "mssup.h"

#define DLM_MAX_LEN_DATE_FORMAT   32
#define DLM_MAX_LEN_DOUBLE_FORMAT 32

typedef __int64 rmoney;

int typeMoney=-1; // 0 - long double, 1 - int64

// । ⨯ 
// ᤥ १ ValueGet  稫

void SetTypeMoney(void) {
    VALUE val;
    ValueMake(&val);

    __int64 m1=12345;
    double m3=987.0;

    ValueSetAs(&val, V_RSLMONEY, V_MONEY, &m1);
    if (val.value.i64val==m1)
        typeMoney=1; // 64

    ValueSetAs(&val, V_RSLMONEY, V_DOUBLE, &m3);
    if (val.value.doubval==m3)
        typeMoney=0; // dbl

    ValueClear(&val);
}

/* 
    RSLSrv ।  DLM ப  ஢ 1251 
    ᫨   뢠    "筮" RSL 
    ⠪    RSLSrv,   RSL । ᯮ짮   
    objstrClaibrateLocaleA("")

*/

    const char * cnvTabDosCharToJson[256] = {
//       0          1          2          3          4          5          6          7          8          9          10 A       11 B       12 C       13 D       14 E       15 F
//       0          1          2          3          4          5          6          7          8          9          10 A       11 B       12 C       13 D       14 E       15 F
/* 0*/   "\\u0000", "\\u263A", "\\u263B", "\\u2665", "\\u2666", "\\u2663", "\\u2660", "\\u2022", "\\u25D8", "\\t",     "\\n",     "\\u2642", "\\u2640", "\\r",     "\\u0013", "\\u0014",
/* 1*/   "\\u0016", "\\u0017", "\\u0018", "\\u0019", "\\u0020", "\\u0021", "\\u0022", "\\u0023", "\\u0024", "\\u0025", "\\u0026", "\\u0027", "\\u0028", "\\u0029", "\\u0030", "\\u0031", 
/* 2*/   " ",       "!",       "\\\"",    "#",       "$",       "%",       "&",       "'",       "(",       ")",       "*",       "+",       ",",       "-",       ".",       "/",       
/* 3*/   "0",       "1",       "2",       "3",       "4",       "5",       "6",       "7",       "8",       "9",       ":",       ";",       "<",       "=",       ">",       "?",
/* 4*/   "@",       "A",       "B",       "C",       "D",       "E",       "F",       "G",       "H",       "I",       "J",       "K",       "L",       "M",       "N",       "O",
/* 5*/   "P",       "Q",       "R",       "S",       "T",       "U",       "V",       "W",       "X",       "Y",       "Z",       "[",       "\\\\",    "]",       "^",       "_",
/* 6*/   "`",       "a",       "b",       "c",       "d",       "e",       "f",       "g",       "h",       "i",       "j",       "k",       "l",       "m",       "n",       "o",    
/* 7*/   "p",       "q",       "r",       "s",       "t",       "u",       "v",       "w",       "x",       "y",       "z",       "{",       "|",       "}",       "~",       "\\u2302",    
/* 8*/   "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",    
/* 9*/   "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",    
/*10*/   "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",    
/*11*/   "\\u2591", "\\u2592", "\\u2593", "\\u2502", "\\u2524", "\\u2561", "\\u2562", "\\u2556", "\\u2555", "\\u2563", "\\u2551", "\\u2557", "\\u255D", "\\u255C", "\\u255B", "\\u2510",    
/*12*/   "\\u2514", "\\u2534", "\\u252C", "\\u251C", "\\u2500", "\\u253C", "\\u255E", "\\u255F", "\\u255A", "\\u2554", "\\u2569", "\\u2566", "\\u2560", "\\u2550", "\\u256C", "\\u2567",    
/*13*/   "\\u2568", "\\u2564", "\\u2565", "\\u2559", "\\u2558", "\\u2552", "\\u2553", "\\u256B", "\\u256A", "\\u2518", "\\u250C", "\\u2588", "\\u2584", "\\u258C", "\\u2590", "\\u2580", 
/*14*/   "",       "",       "",       "",       "",       "",       "",        "",      "",       "",       "",       "",       "",       "",       "",       "",    
/*15*/   "",       "",       "\\u0404", "\\u0454", "\\u0407", "\\u0457", "\\u040E", "\\u045E", "\\u00B0", "\\u2219", "\\u00B7", "\\u221A", "\\u2216", "\\u00A4", "\\u22A0", "\\u00A0"};



    const char * cnvTabWinCharToJson[256] = {
//       0          1          2          3          4          5          6          7          8          9          10 A       11 B       12 C       13 D       14 E       15 F
/* 0*/  "\\u0000", "\\u263A", "\\u263B", "\\u2665", "\\u2666", "\\u2663", "\\u2660", "\\u2022", "\\u25D8", "\\t",     "\\n",     "\\u2642", "\\u2640", "\\r",     "\\u0013", "\\u0014",
/* 1*/  "\\u0016", "\\u0017", "\\u0018", "\\u0019", "\\u0020", "\\u0021", "\\u0022", "\\u0023", "\\u0024", "\\u0025", "\\u0026", "\\u0027", "\\u0028", "\\u0029", "\\u0030", "\\u0031", 
/* 2*/  " ",       "!",       "\\\"",    "#",       "$",       "%",       "&",       "'",       "(",       ")",       "*",       "+",       ",",       "-",       ".",       "/",       
/* 3*/  "0",       "1",       "2",       "3",       "4",       "5",       "6",       "7",       "8",       "9",       ":",       ";",       "<",       "=",       ">",       "?",
/* 4*/  "@",       "A",       "B",       "C",       "D",       "E",       "F",       "G",       "H",       "I",       "J",       "K",       "L",       "M",       "N",       "O",
/* 5*/  "P",       "Q",       "R",       "S",       "T",       "U",       "V",       "W",       "X",       "Y",       "Z",       "[",       "\\\\",    "]",       "^",       "_",
/* 6*/  "`",       "a",       "b",       "c",       "d",       "e",       "f",       "g",       "h",       "i",       "j",       "k",       "l",       "m",       "n",       "o",    
/* 7*/  "p",       "q",       "r",       "s",       "t",       "u",       "v",       "w",       "x",       "y",       "z",       "{",       "|",       "}",       "~",       "\\u2302",    
/* 8*/  "\\u0402", "\\u0403", "\\u201A", "\\u0453", "\\u201E", "\\u2026", "\\u2020", "\\u2021", "\\u20AC", "\\u2030", "\\u0409", "\\u2039", "\\u040A", "\\u040C", "\\u040B", "\\u040F",    
/* 9*/  "\\u0452", "\\u2018", "\\u2019", "\\u201C", "\\u201D", "\\u2022", "\\u2013", "\\u2014", "_",       "_",       "_",       "_",       "_",       "_",       "_",       "_",    
/*10*/  " ",       "\\u040E", "\\u045E", "\\u0408", "\\u00A4", "\\u0490", "\\u00A6", "\\u00A7", "",       "\\u00A9", "\\u0404", "\\u00AB", "\\u00AC", "\\u00AD", "\\u00AE", "\\u0407",    
/*11*/  "\\u00B0", "\\u00B1", "\\u0406", "\\u0456", "\\u0491", "\\u00B5", "\\u00B6", "\\u00B7", "",       "",       "\\u0454", "\\u00BB", "\\u0458", "\\u0405", "\\u0455", "\\u0457",    
/*12*/  "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",    
/*13*/  "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",    
/*14*/  "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",    
/*15*/  "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       "",       ""};


int iRslCodePage=866;
const char ** cnvTabCharToJson=cnvTabDosCharToJson;

static void objstrClaibrateLocaleA(void) {
    VALUE *vStr;
    int ret=-1;

    if (GetParm (0,&vStr) && vStr->v_type == V_STRING) { 
        if(*(vStr->value.string)=='') {
            ret=866;
            cnvTabCharToJson=cnvTabDosCharToJson;
        } else if(*(vStr->value.string)=='') {
            iRslCodePage=ret=1251;
            cnvTabCharToJson=cnvTabWinCharToJson;
        }
    } else {
        RslError("ࠬ 1   ப  㪢 ");
    }
    ReturnVal(V_INTEGER,(void *)&ret);
}

/*
static void objstrABC866(void) {
    char * s="񦧨";
    ReturnVal(V_STRING,(void *)s);
}

static void objstrABC1251(void) {
    char * s="";
    ReturnVal(V_STRING,(void *)s);
}
*/

class  TObjString {

    void getString(void) {
        ReturnVal(V_STRING,(void*)str.c_str());
    }

public:

   TObjString (TGenObject *pThis = NULL) {
      }

   ~TObjString () {
      }


   RSL_CLASS(TObjString)

   RSL_INIT_DECL() {
      VALUE *v;
      GetParm (*firstParmOffs,&v);
      int N=GetNumParm();
      VALUE *vVal;
      try {
          str="";
          for(int iParm=*firstParmOffs;iParm<N;iParm++) 
              if (GetParm (iParm,  &vVal)) {
                  switch (vVal->v_type) {
                  case V_STRING:
                      str+=vVal->value.string;
                  }
              }

      }
      catch (...){
          RslError("string init error");
      }
        iJsonKeyValueCounter=0;
        strncpy(sDateFormat,       "\"%Y-%m-%d\"", DLM_MAX_LEN_DATE_FORMAT-1);
        strncpy(sDoubleFormat,     "%g",           DLM_MAX_LEN_DOUBLE_FORMAT-1);
        strncpy(sLongDoubleFormat, "%lg",          DLM_MAX_LEN_DOUBLE_FORMAT-1);
    }
                  
    RSL_METHOD_DECL(Add) {

        VALUE *vVal;
        int N=GetNumParm();

        for(int iParm=1;iParm<N;iParm++) 
            if (GetParm (iParm,  &vVal)) {
                switch (vVal->v_type) {
                case V_STRING:
                    str+=vVal->value.string;
                }
            }


        return 0;

    }


    RSL_METHOD_DECL(AddJson) {

        VALUE *vVal;
        int N=GetNumParm();

        for(int iParm=1;iParm<N;iParm++) 
            if (GetParm (iParm,  &vVal)) {
                switch (vVal->v_type) {

                case V_STRING:
                    std::string result("");
                    for(char * p=vVal->value.string;*p;p++) {
                        unsigned char idx=*p;
                        std::string newChar(cnvTabCharToJson[idx]);
                        //result+=newChar;
                        str+=newChar;
                    }

                    //str+=result;
                }
            }


        return 0;

    }



    RSL_METHOD_DECL(AddJsonKeyValue) {

        VALUE *vKey;
        VALUE *vVal;

        if (GetParm (1,  &vKey) && vKey->v_type==V_STRING && GetParm (2,  &vVal)) {

            if (iJsonKeyValueCounter++)
                str+=',';

            str+='"';
            if (true) {
                // safe key
                for(char * p=vKey->value.string;*p;p++) {
                    unsigned char idx=*p;
                    std::string newChar(cnvTabCharToJson[idx]);
                    //result+=newChar;
                    str+=newChar;
                }
            } else {
                // unsafe key
                str+=vKey->value.string;
            }
            str+="\":";

            switch (vVal->v_type) {

            case V_STRING:
                str+='"';
                {
                    std::string result("");
                    for(char * p=vVal->value.string;*p;p++) {
                        unsigned char idx=*p;
                        std::string newChar(cnvTabCharToJson[idx]);
                        //result+=newChar;
                        str+=newChar;
                    }
                }
                str+='"';
                break;

            case V_BOOL:
                str+=((vVal->value.boolval)?"true":"false");
                break;

            case V_INTEGER:
                str+=std::to_string(vVal->value.intval);
                break;

            case V_DOUBLE:
                {
                    char tmpbuf[_CVTBUFSIZE];  
                    //_gcvt(vVal->value.doubval, _CVTBUFSIZE-1, tmpbuf);
                    _sprintf_s_l(tmpbuf, _CVTBUFSIZE, sDoubleFormat, _create_locale(LC_ALL,"en-US"), vVal->value.doubval);
                    str+=tmpbuf;
                }
                //str+=std::to_string(vVal->value.doubval);
                break;

            case V_DOUBLEL:
                {
                    char tmpbuf[_CVTBUFSIZE];  
                    _sprintf_s_l(tmpbuf, _CVTBUFSIZE, sLongDoubleFormat, _create_locale(LC_ALL,"en-US"), vVal->value.doubvalL);
                    str+=tmpbuf;
                }
                //str+=std::to_string(vVal->value.doubval);
                break;

            //case V_DOUBLEL:
            //    str+=std::to_string(vVal->value.doubvalL);
            //    break;

            case V_MONEY:
                // Numeric_t tmp_money_num;
                // long double tmp_money_f;
                // V_MONEY-
                // V_NUMERIC cnverr
                //if(!ValueGet(vVal, V_DOUBLEL, &tmp_money_f))
                //    MsgBox("Money cnv error");

                switch (typeMoney) {

                case 0: // long double 
                    { 
    	                char tmpbuf[40];

                        //print("Debug MONEY 1: %.4lf \r\n",tmp_money_f); ////////////////////////////////////
                        //print("Debug MONEY 2: %.4lf \r\n",vVal->value.doubvalL/100.0); ////////////////////////////////////

                        _sprintf_s_l(tmpbuf,sizeof(tmpbuf),"%.2lf",_create_locale(LC_ALL,"en-US"),vVal->value.doubvalL/100);

                        str+=tmpbuf;

                    }
                    break;
                     
                case 1: // int 64
                    { 
                        // 0 -> 0.00
                        // 100 -> 0.01
                        // 1200 -> 0.12
                        // 12300 -> 1.23

                        AddI64(vVal->value.i64val);
                        /*
                        if (vVal->value.i64val) {
        	            char tmpbuf[40];
        	            char * sMoney=tmpbuf;
                            _i64toa(vVal->value.i64val, tmpbuf, 10);

                            if (*sMoney=='-') {
                                sMoney++;
                                str+='-';
                            }

                            int l=strlen(sMoney);
                            if (l<3)
                                str+="error xxs";
                            else {
                                if (sMoney[l-1]=='0' && sMoney[l-2]=='0') {
                                    if (l==3) {
                                        sMoney[l-2]='\0';
                                        str+="0.0";
                                    } else if (l==4) {
                                        sMoney[l-2]='\0';
                                        str+="0.";
                                    } else {
                                        sMoney[l-1]='\0';
                                        sMoney[l-2]=sMoney[l-3];
                                        sMoney[l-3]=sMoney[l-4];
                                        sMoney[l-4]='.';
                                    }
                                    str+=sMoney;
                                } else 
                                    str+="error 00";
                            }

                        } else {
                            str+="0.00";
                        }
                        */
                    } // if money type
                    break;

                default:
                    RslError("訡 । ⨯ money");

                } // switch
                break;

            case V_MONEYL:
                str+="moneyL";
                // str+=std::to_string(vVal->value.i64val);
                break;
            
            case V_NUMERIC:
                // str+="numeric";
                {
                    long long money;

                    if(ValueGet(vVal, V_MONEY, &money)) {
	                //char tmpbuf[40];
	                //char * sMoney=tmpbuf;
                       // _sprintf_s_l(tmpbuf,sizeof(tmpbuf),"%lli",_create_locale(LC_ALL,"en-US"),money);
                        //_i64toa(money, tmpbuf, 10);

                        //str+=tmpbuf;
                        AddI64(money);

                    } else
                        str+="numeric cnv error";
                }
                break;

            case V_DATE:
                {
	            char tmpbuf[128];
	            tmpbuf[0]='\0';
                    struct tm tmdate={0,0,0, 0,0,0, 0,0, 0};

        	    bdate btrdate=vVal->value.date;
        	    if (btrdate.day==0 && btrdate.mon==0 && btrdate.year==0) 
        	        str+="null";
        	    else {
            		tmdate.tm_mday=btrdate.day;
            		tmdate.tm_mon =btrdate.mon-1;
            		tmdate.tm_year=btrdate.year-1900;
                        if(-1==_mktime32( &tmdate)) 
        	            str+="\"error\"";
        	        else {
            	            strftime( tmpbuf, sizeof(tmpbuf), sDateFormat, &tmdate );
            	            str+=tmpbuf;
        	        }
           	    }
   		}
                break;



            default:
                str+="unknown type value";

                //str+=result;
            }

        }

        return 0;

    }


    RSL_METHOD_DECL(InsertAfter) {

        VALUE *vVal;

        if (GetParm (1,  &vVal)) {
            switch (vVal->v_type) {
            case V_STRING:
                str+=vVal->value.string;
            }
        }

        return 0;

    }

    RSL_METHOD_DECL(InsertBefore) {

        VALUE *vVal;

        if (GetParm (1,  &vVal)) {
            switch (vVal->v_type) {
            case V_STRING:
                str.insert(0,vVal->value.string);
            }
        }

        return 0;

    }

    RSL_METHOD_DECL(Clear) {
        str.clear();
        iJsonKeyValueCounter=0;
        return 0;
    }

    RSL_METHOD_DECL(ResetJsonKeyValue) {
        iJsonKeyValueCounter=0;
        return 0;
    }


    RSL_GETPROP_DECL(ToString) {
        getString();
        return 0;

    }

    RSL_GETPROP_DECL(String) {
        getString();
        return 0;

    }

    RSL_GETPROP_DECL(Get) {
        getString();
        return 0;

    }

    RSL_GETPROP_DECL(Value) {
        getString();
        return 0;

    }

    RSL_GETPROP_DECL(Length) {
        int l=str.length();
        ReturnVal(V_INTEGER,(void*)&l);
        return 0;

    }

    RSL_GETPROP_DECL(IsEmpty) {
        bool flag=str.empty();
        ReturnVal(V_BOOL,(void*)&flag);
        return 0;
    }

    RSL_METHOD_DECL(Save) {
        
        bool flag=false;
        VALUE *vVal;

        if (GetParm (1,  &vVal) && vVal->v_type==V_STRING) {
            std::ofstream out(vVal->value.string, std::ofstream::out);
            if (out) {
                out << str;
                flag=true;
            }
        }
        ReturnVal(V_BOOL,(void*)&flag);
        return 0;
    }

    RSL_GETPROP_DECL(RslDlmVersion) {
        int v=RslDlmVersion();
        ReturnVal(V_INTEGER,(void*)&v);
        return 0;

    }

    RSL_GETPROP_DECL(DateFormat) {
        ValueClear(retVal);
        ValueSet(retVal, V_STRING, sDateFormat);
        return 0;
    }

    RSL_GETPROP_DECL(DoubleFormat) {
        ValueClear(retVal);
        ValueSet(retVal, V_STRING, sDoubleFormat);
        return 0;
    }

    RSL_GETPROP_DECL(LongDoubleFormat) {
        ValueClear(retVal);
        ValueSet(retVal, V_STRING, sLongDoubleFormat);
        return 0;
    }

    RSL_PUTPROP_DECL(DateFormat) {
        if (newVal->v_type == V_STRING) {
            strncpy(sDateFormat, newVal->value.string, DLM_MAX_LEN_DATE_FORMAT-1);
            // sDateFormat[DLM_MAX_LEN_DATE_FORMAT-1] = '\0';
        }
        return 0;
    }

    RSL_PUTPROP_DECL(LongDoubleFormat) {
        if (newVal->v_type == V_STRING) {
            strncpy(sLongDoubleFormat, newVal->value.string, DLM_MAX_LEN_DOUBLE_FORMAT-1);
            // sDateFormat[DLM_MAX_LEN_DOUBLE_FORMAT-1] = '\0';
        }
        return 0;
    }

    RSL_PUTPROP_DECL(DoubleFormat) {
        if (newVal->v_type == V_STRING) {
            strncpy(sDoubleFormat, newVal->value.string, DLM_MAX_LEN_DOUBLE_FORMAT-1);
            // sDateFormat[DLM_MAX_LEN_DOUBLE_FORMAT-1] = '\0';
        }
        return 0;
    }

    RSL_METHOD_DECL(SetDateFormatDMY) {
        strncpy(sDateFormat, "\"%d.%m.%Y\"", DLM_MAX_LEN_DATE_FORMAT-1);
        return 0;
    }


    RSL_GETPROP_DECL(MoneyType) {
        ReturnVal(V_INTEGER,(void*)&typeMoney);
        return 0;

    }

private:
    std::string str;
    int iJsonKeyValueCounter;
    char sDateFormat[DLM_MAX_LEN_DATE_FORMAT];
    char sDoubleFormat[DLM_MAX_LEN_DOUBLE_FORMAT];
    char sLongDoubleFormat[DLM_MAX_LEN_DOUBLE_FORMAT];

    void AddI64(long long ii) {
        if (ii) {
            char tmpbuf[40];
            char * sMoney=tmpbuf;
            _i64toa(ii, tmpbuf, 10);

            if (*sMoney=='-') {
                sMoney++;
                str+='-';
            }

            int l=strlen(sMoney);
            if (l<3)
                str+="error xxs";
            else {
                if (sMoney[l-1]=='0' && sMoney[l-2]=='0') {
                    if (l==3) {
                        sMoney[l-2]='\0';
                        str+="0.0";
                    } else if (l==4) {
                        sMoney[l-2]='\0';
                        str+="0.";
                    } else {
                        sMoney[l-1]='\0';
                        sMoney[l-2]=sMoney[l-3];
                        sMoney[l-3]=sMoney[l-4];
                        sMoney[l-4]='.';
                    }
                    str+=sMoney;
                } else 
                    str+="error 00";
            }

        } else {
            str+="0.00";
        }
    }
};


RSL_CLASS_BEGIN(TObjString)
    RSL_METH       (Add)
    RSL_METH       (AddJson)
    RSL_METH       (AddJsonKeyValue)
    RSL_METH       (ResetJsonKeyValue)
    RSL_METH       (InsertBefore)
    RSL_METH       (InsertAfter)
    RSL_METH       (Clear)
    RSL_METH       (Save)
    RSL_METH       (SetDateFormatDMY)
    RSL_PROP_METH  (Length)
    RSL_PROP_METH  (ToString)
    RSL_PROP_METH  (String)
    RSL_PROP_METH  (Value)
    RSL_PROP_METH  (Get)
    RSL_PROP_METH  (IsEmpty)
    RSL_PROP_METH  (RslDlmVersion) // for info
    RSL_PROP_METH  (MoneyType)     // for info
    RSL_PROP_METH2 (DateFormat)
    RSL_PROP_METH2 (DoubleFormat)
    RSL_PROP_METH2 (LongDoubleFormat)
    RSL_INIT
RSL_CLASS_END  


EXP32 void DLMAPI EXP AddModuleObjects (void) {
    setlocale(LC_ALL,".866");
    RslAddUniClass (TObjString::TablePtr,true);
    AddStdProc(V_INTEGER,"objstrClaibrateLocaleA", objstrClaibrateLocaleA, 0);
    // AddStdProc(V_STRING, "objstrABC1251",          objstrABC1251,          0);
    // AddStdProc(V_STRING, "objstrABC866",           objstrABC866,           0);
    SetTypeMoney();
}
